diff -ur -x .git seabios-old/src/config.h seabios-new/src/config.h
--- seabios-old/src/config.h	2008-11-10 01:01:06.000000000 +0100
+++ seabios-new/src/config.h	2008-11-10 00:39:52.000000000 +0100
@@ -13,13 +13,13 @@
 #define CONFIG_APPNAME4 "BXPC"
 
 // Configure as a coreboot payload.
-#define CONFIG_COREBOOT 0
+#define CONFIG_COREBOOT 1
 
 // Control how verbose debug output is.
-#define CONFIG_DEBUG_LEVEL 1
+#define CONFIG_DEBUG_LEVEL 3
 
 // Send debugging information to serial port
-#define CONFIG_DEBUG_SERIAL 0
+#define CONFIG_DEBUG_SERIAL 1
 
 // Support for int13 floppy drive access
 #define CONFIG_FLOPPY_SUPPORT 1
@@ -101,10 +101,10 @@
 #define SEG_BDA      0x0000
 
 // Segment definitions in 32bit mode.
-#define SEG32_MODE32_CS (2 << 3) // 0x10
-#define SEG32_MODE32_DS (3 << 3) // 0x18
-#define SEG32_MODE16_CS (4 << 3) // 0x20
-#define SEG32_MODE16_DS (5 << 3) // 0x28
+#define SEG32_MODE32_CS (1 << 3) // 0x08
+#define SEG32_MODE32_DS (2 << 3) // 0x10
+#define SEG32_MODE16_CS (3 << 3) // 0x18
+#define SEG32_MODE16_DS (4 << 3) // 0x20
 
 // Debugging levels.  If non-zero and CONFIG_DEBUG_LEVEL is greater
 // than the specified value, then the corresponding irq handler will
diff -ur -x .git seabios-old/src/post.c seabios-new/src/post.c
--- seabios-old/src/post.c	2008-11-10 01:01:06.000000000 +0100
+++ seabios-new/src/post.c	2008-11-10 00:39:11.000000000 +0100
@@ -293,9 +293,9 @@
     call16(&br);
 }
 
-// 32-bit entry point.
+
 void VISIBLE32
-_start()
+_init()
 {
     init_dma();
     check_restart_status();
@@ -311,6 +311,14 @@
 
     // Perform main setup code.
     post();
+}
+
+// 32-bit entry point.
+void VISIBLE32
+_start()
+{
+    // Call init
+    _init();
 
     // Present the user with a bootup menu.
     interactive_bootmenu();
@@ -333,3 +341,4 @@
 // functions to not be exported as a global variable - force _start
 // to be global here.
 asm(".global _start");
+asm(".global _init");
diff -ur -x .git seabios-old/src/romlayout.S seabios-new/src/romlayout.S
--- seabios-old/src/romlayout.S	2008-11-10 01:01:06.000000000 +0100
+++ seabios-new/src/romlayout.S	2008-11-10 00:39:25.000000000 +0100
@@ -7,7 +7,6 @@
 
 #include "config.h"
 
-
 /****************************************************************
  * Include of 16bit C code
  ****************************************************************/
@@ -539,6 +538,20 @@
         ORG 0xff54
         IRQ_ENTRY_ARG 05
 
+.code32
+        ORG 0xffe0 // coreboot Entry Point
+        cli
+        cld
+        lidtl (BUILD_BIOS_ADDR + pmode_IDT_info)
+  //      lgdtl (BUILD_BIOS_ADDR + rombios32_gdt_48)
+  //      movl $BUILD_STACK_ADDR, %esp
+  //      ljmpl $PROTECTED_MODE_CS, $_code32__start
+
+
+	calll (_code32__init - BUILD_BIOS_ADDR)
+	ret
+.code16gcc
+
         ORG 0xfff0 // Power-up Entry Point
         ljmpw $SEG_BIOS, $post16
 
